org.apache.hc.core5.http.nio.support.classic

## Class AbstractClassicEntityConsumer<T>

- java.lang.Object
- - org.apache.hc.core5.http.nio.support.classic.AbstractClassicEntityConsumer<T>

- Type Parameters:
    `T` - entity representation.
  All Implemented Interfaces:
    AsyncDataConsumer, AsyncEntityConsumer<T>, ResourceHolder

      public abstract class AbstractClassicEntityConsumer<T>
      extends Object
      implements AsyncEntityConsumer<T>

  `AsyncEntityConsumer` implementation that acts as a compatibility layer for classic `InputStream` based interfaces. Blocking input processing is executed through an `Executor`.
  Since:
    5.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractClassicEntityConsumer(int initialBufferSize, Executor executor)`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `consume(ByteBuffer src)` Triggered to pass incoming data to the data consumer.
    `protected abstract T` | `consumeData(ContentType contentType, InputStream inputStream)` Processes entity data from the given stream.
    `void` | `failed(Exception cause)` Triggered to signal a failure in data processing.
    `T` | `getContent()` Returns the result of entity processing when it becomes available or `null` if the entity is still being received.
    `Exception` | `getException()`
    `void` | `releaseResources()`
    `void` | `streamEnd(List<? extends Header> trailers)` Triggered to signal termination of the data stream.
    `void` | `streamStart(EntityDetails entityDetails, FutureCallback<T> resultCallback)` Signals beginning of an incoming request entity stream.
    `void` | `updateCapacity(CapacityChannel capacityChannel)` Triggered to signal ability of the underlying data stream to receive data capacity update.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AbstractClassicEntityConsumer

          public AbstractClassicEntityConsumer(int initialBufferSize,
                                               Executor executor)

  - ### Method Detail

    - #### consumeData

          protected abstract T consumeData(ContentType contentType,
                                           InputStream inputStream)
                                    throws IOException

      Processes entity data from the given stream.
      Parameters:
        `contentType` - the entity content type
        `inputStream` - the input stream
      Returns:
        the result of entity processing.
      Throws:
        `IOException` - in case of an I/O error.

    - #### updateCapacity

          public final void updateCapacity(CapacityChannel capacityChannel)
                                    throws IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to signal ability of the underlying data stream to receive data capacity update. The data consumer can choose to write data immediately inside the call or asynchronously at some later point.
      Specified by:
        `updateCapacity` in interface `AsyncDataConsumer`
      Parameters:
        `capacityChannel` - the channel for capacity updates.
      Throws:
        `IOException` - in case of an I/O error.

    - #### streamStart

          public final void streamStart(EntityDetails entityDetails,
                                        FutureCallback<T> resultCallback)
                                 throws HttpException,
                                        IOException

      Description copied from interface: `AsyncEntityConsumer`
      Signals beginning of an incoming request entity stream.
      Specified by:
        `streamStart` in interface `AsyncEntityConsumer<T>`
      Parameters:
        `entityDetails` - the details of the incoming message entity.
        `resultCallback` - the result callback.
      Throws:
        `HttpException` - in case of an HTTP protocol violation.
        `IOException` - in case of an I/O error.

    - #### consume

          public final void consume(ByteBuffer src)
                             throws IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to pass incoming data to the data consumer. The consumer must consume the entire content of the data buffer. The consumer must stop incrementing its capacity on the capacity channel if it is unable to accept more data. Once the data consumer has handled accumulated data or allocated more intermediate storage it can update its capacity information on the capacity channel.
      Specified by:
        `consume` in interface `AsyncDataConsumer`
      Parameters:
        `src` - data source.
      Throws:
        `IOException` - in case of an I/O error.

    - #### streamEnd

          public final void streamEnd(List<? extends Header> trailers)
                               throws HttpException,
                                      IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to signal termination of the data stream.
      Specified by:
        `streamEnd` in interface `AsyncDataConsumer`
      Parameters:
        `trailers` - data stream trailers.
      Throws:
        `HttpException` - in case of an HTTP protocol violation.
        `IOException` - in case of an I/O error.

    - #### failed

          public final void failed(Exception cause)

      Description copied from interface: `AsyncEntityConsumer`
      Triggered to signal a failure in data processing.
      Specified by:
        `failed` in interface `AsyncEntityConsumer<T>`
      Parameters:
        `cause` - the cause of the failure.

    - #### getException

          public final Exception getException()

    - #### getContent

          public final T getContent()

      Description copied from interface: `AsyncEntityConsumer`
      Returns the result of entity processing when it becomes available or `null` if the entity is still being received.
      Specified by:
        `getContent` in interface `AsyncEntityConsumer<T>`
      Returns:
        the response processing result.

    - #### releaseResources

          public void releaseResources()

      Specified by:
        `releaseResources` in interface `ResourceHolder`

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.